//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class AccountUpdateRequest: JSONDecodable, JSONEncodable, PrettyPrintable {

    /** The id of the payment instrument to use by default for account transactions. */
    public var defaultPaymentInstrumentId: String?

    /** The first name of the account holder. */
    public var firstName: String?

    /** The last name of the account holder. */
    public var lastName: String?

    /** The classification rating defining the minimum rating level a user should be
forced to enter the account pin code for playback. Anything at this rating
level or above will require the pin for playback.

e.g. AUOFLC-MA15+

If you want to disable this guard pass an empty string or `null`.
 */
    public var minRatingPlaybackGuard: String?

    /** Whether usage tracking is associated with an account or anonymous. */
    public var trackingEnabled: Bool?

    public init(defaultPaymentInstrumentId: String? = nil, firstName: String? = nil, lastName: String? = nil, minRatingPlaybackGuard: String? = nil, trackingEnabled: Bool? = nil) {
        self.defaultPaymentInstrumentId = defaultPaymentInstrumentId
        self.firstName = firstName
        self.lastName = lastName
        self.minRatingPlaybackGuard = minRatingPlaybackGuard
        self.trackingEnabled = trackingEnabled
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        defaultPaymentInstrumentId = jsonDictionary.json(atKeyPath: "defaultPaymentInstrumentId")
        firstName = jsonDictionary.json(atKeyPath: "firstName")
        lastName = jsonDictionary.json(atKeyPath: "lastName")
        minRatingPlaybackGuard = jsonDictionary.json(atKeyPath: "minRatingPlaybackGuard")
        trackingEnabled = jsonDictionary.json(atKeyPath: "trackingEnabled")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        if let defaultPaymentInstrumentId = defaultPaymentInstrumentId {
            dictionary["defaultPaymentInstrumentId"] = defaultPaymentInstrumentId
        }
        if let firstName = firstName {
            dictionary["firstName"] = firstName
        }
        if let lastName = lastName {
            dictionary["lastName"] = lastName
        }
        if let minRatingPlaybackGuard = minRatingPlaybackGuard {
            dictionary["minRatingPlaybackGuard"] = minRatingPlaybackGuard
        }
        if let trackingEnabled = trackingEnabled {
            dictionary["trackingEnabled"] = trackingEnabled
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
