//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class ServiceError: JSONDecodable, JSONEncodable, PrettyPrintable {

    /** A description of the error. */
    public var message: String

    /** An optional code classifying the error. Should be taken in the context of the http status code. */
    public var code: Int?

    public init(message: String, code: Int? = nil) {
        self.message = message
        self.code = code
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        message = try jsonDictionary.json(atKeyPath: "message")
        code = jsonDictionary.json(atKeyPath: "code")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        dictionary["message"] = message
        if let code = code {
            dictionary["code"] = code
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
